package com.engine.htsc.ReimbursementFlow.model;

public class ExcelPayDetailZhiFu {
    private String consolidationKey;
    private String entryNo;
    private String subsidiary;
    private String currency;
    private String exchangeRate;
    private String postingPeriod;
    private String date;
    private String reversalDate;
    private String deferEntry;
    private String memo;
    private String account;
    private String debit;
    private String credit;
    private String department;
    private String location;
    private String financialProduct;
    private String clientCounterParty;
    private String projectName;
    private String journalEntryLine;
    private String employee;
    private String beneBankCode;
    private String beneType;
    private String beneName;
    private String creditAmount;
    private String paymentDetails;
    private String chargePayCurrency;
    private String subsidiaryForPayment;
    public  String cellName [] = new String[27];
    public ExcelPayDetailZhiFu(){
        cellName[0]="Consolidation Key";
        cellName[1]="Entry No";
        cellName[2]="Subsidiary";
        cellName[3]="Currency";
        cellName[4]="Exchange Rate";
        cellName[5]="Posting Period";
        cellName[6]="Date";
        cellName[7]="Reversal Date";
        cellName[8]="Defer Entry";
        cellName[9]="Memo";
        cellName[10]="Account";
        cellName[11]="Debit";
        cellName[12]="Credit";
        cellName[13]="Department";
        cellName[14]="Location";
        cellName[15]="Financial Product";
        cellName[16]="Client/CounterParty";
        cellName[17]="Project Name";
        cellName[18]="Journal Entry Line : Memo ";
        cellName[19]="Employee";
        cellName[20]="Bene.A/C Bank Code";
        cellName[21]="Bene.A/C Type*";
        cellName[22]="Bene. Name/Address";
        cellName[23]="Credit Amount*";
        cellName[24]="Payment Details";
        cellName[25]="Charge Pay Currency*";
        cellName[26]="Subsidiary for payment";

    }

    public String getConsolidationKey() {
        return consolidationKey;
    }

    public void setConsolidationKey(String consolidationKey) {
        this.consolidationKey = consolidationKey;
    }

    public String getEntryNo() {
        return entryNo;
    }

    public void setEntryNo(String entryNo) {
        this.entryNo = entryNo;
    }

    public String getSubsidiary() {
        return subsidiary;
    }

    public void setSubsidiary(String subsidiary) {
        this.subsidiary = subsidiary;
    }

    public String getCurrency() {
        return currency;
    }

    public void setCurrency(String currency) {
        this.currency = currency;
    }

    public String getExchangeRate() {
        return exchangeRate;
    }

    public void setExchangeRate(String exchangeRate) {
        this.exchangeRate = exchangeRate;
    }

    public String getPostingPeriod() {
        return postingPeriod;
    }

    public void setPostingPeriod(String postingPeriod) {
        this.postingPeriod = postingPeriod;
    }

    public String getDate() {
        return date;
    }

    public void setDate(String date) {
        this.date = date;
    }

    public String getReversalDate() {
        return reversalDate;
    }

    public void setReversalDate(String reversalDate) {
        this.reversalDate = reversalDate;
    }

    public String getDeferEntry() {
        return deferEntry;
    }

    public void setDeferEntry(String deferEntry) {
        this.deferEntry = deferEntry;
    }

    public String getMemo() {
        return memo;
    }

    public void setMemo(String memo) {
        this.memo = memo;
    }

    public String getAccount() {
        return account;
    }

    public void setAccount(String account) {
        this.account = account;
    }

    public String getDebit() {
        return debit;
    }

    public void setDebit(String debit) {
        this.debit = debit;
    }

    public String getCredit() {
        return credit;
    }

    public void setCredit(String credit) {
        this.credit = credit;
    }

    public String getDepartment() {
        return department;
    }

    public void setDepartment(String department) {
        this.department = department;
    }

    public String getLocation() {
        return location;
    }

    public void setLocation(String location) {
        this.location = location;
    }

    public String getFinancialProduct() {
        return financialProduct;
    }

    public void setFinancialProduct(String financialProduct) {
        this.financialProduct = financialProduct;
    }

    public String getClientCounterParty() {
        return clientCounterParty;
    }

    public void setClientCounterParty(String clientCounterParty) {
        this.clientCounterParty = clientCounterParty;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getJournalEntryLine() {
        return journalEntryLine;
    }

    public void setJournalEntryLine(String journalEntryLine) {
        this.journalEntryLine = journalEntryLine;
    }

    public String getEmployee() {
        return employee;
    }

    public void setEmployee(String employee) {
        this.employee = employee;
    }

    public String getBeneBankCode() {
        return beneBankCode;
    }

    public void setBeneBankCode(String beneBankCode) {
        this.beneBankCode = beneBankCode;
    }

    public String getBeneType() {
        return beneType;
    }

    public void setBeneType(String beneType) {
        this.beneType = beneType;
    }

    public String getBeneName() {
        return beneName;
    }

    public void setBeneName(String beneName) {
        this.beneName = beneName;
    }

    public String getCreditAmount() {
        return creditAmount;
    }

    public void setCreditAmount(String creditAmount) {
        this.creditAmount = creditAmount;
    }

    public String getPaymentDetails() {
        return paymentDetails;
    }

    public void setPaymentDetails(String paymentDetails) {
        this.paymentDetails = paymentDetails;
    }

    public String getChargePayCurrency() {
        return chargePayCurrency;
    }

    public void setChargePayCurrency(String chargePayCurrency) {
        this.chargePayCurrency = chargePayCurrency;
    }

    public String getSubsidiaryForPayment() {
        return subsidiaryForPayment;
    }

    public void setSubsidiaryForPayment(String subsidiaryForPayment) {
        this.subsidiaryForPayment = subsidiaryForPayment;
    }

    public String[] getCellName() {
        return cellName;
    }

    public void setCellName(String[] cellName) {
        this.cellName = cellName;
    }
}
