package com.engine.htsc.cowork.service.impl;

import com.engine.core.impl.Service;
import com.engine.htsc.cowork.cmd.CoWorkCmd;
import com.engine.htsc.cowork.cmd.CoWorkTopButtonCmd;
import com.engine.htsc.cowork.cmd.CoXzWorkCmd;
import com.engine.htsc.cowork.service.CoWorkService;
import weaver.hrm.User;

import java.util.Map;

public class CoWorkServiceImpl extends Service implements CoWorkService {

    @Override
    public Map<String, Object> doGetIsComplete(Map<String, Object> params, User user) {
        return commandExecutor.execute(new CoWorkCmd(params,user));
    }

    @Override
    public Map<String, Object> doGetXzComplete(Map<String, Object> params, User user) {
        return commandExecutor.execute(new CoXzWorkCmd(params,user));
    }

    @Override
    public Map<String, Object> doGetTopButton(Map<String, Object> params, User user) {
        return commandExecutor.execute(new CoWorkTopButtonCmd(params,user));
    }


}
