package com.engine.htsc.cube.task;

public class SyncFavoriteThread extends Thread {

    /**
     * 收藏人工号
     */
    private String user;
    /**
     * 建模表主键
     */
    private String billids;
    /**
     * 1收藏，0取消
     */
    private Integer isCancelCollect;


    public SyncFavoriteThread(String user, String billids, Integer isCancelCollect) {
        this.user = user;
        this.billids = billids;
        this.isCancelCollect = isCancelCollect;
    }

    @Override
    public void run() {
        FavoriteTask task = new FavoriteTask();
        task.batchSyncFavorite(user, billids, isCancelCollect);
        super.run();
    }
}
