package com.engine.htsc.hthy.service.impl;

import com.engine.core.impl.Service;
import com.engine.htsc.hthy.cmd.HymbDataListCmd;
import com.engine.htsc.hthy.cmd.HyqdDataListCmd;
import com.engine.htsc.hthy.cmd.HyxxDataByMailCmd;
import com.engine.htsc.hthy.cmd.SendMailByMeetinglCmd;
import com.engine.htsc.hthy.service.HtscMettingService;

import java.util.Map;


public class HhtscMeetingServiceImpl extends Service implements HtscMettingService {


    @Override
    public Map<String, Object> getHyqdData(Map<String,Object> params) {
        return commandExecutor.execute(new HyqdDataListCmd(params));
    }

    @Override
    public Map<String, Object> getHymbData(Map<String, Object> params) {
        return commandExecutor.execute(new HymbDataListCmd(params));
    }

    @Override
    public Map<String, Object> getHyxxByMail(Map<String, Object> params) {
        return commandExecutor.execute(new HyxxDataByMailCmd(params));
    }

    @Override
    public Map<String, Object> sendMailByMeeting(Map<String, Object> params) {
        return commandExecutor.execute(new SendMailByMeetinglCmd(params));
    }
}
