package com.engine.htsc.itxqlc.service.impl;

import com.engine.core.impl.Service;
import com.engine.htsc.itxqlc.cmd.ItxqlcFreeNodeCmd;
import com.engine.htsc.itxqlc.cmd.ItxqlcLdspCmd;
import com.engine.htsc.itxqlc.cmd.ItxqlcXgxtCmd;
import com.engine.htsc.itxqlc.cmd.ItxqlcXxjsbCmd;
import com.engine.htsc.itxqlc.service.ItxqlcService;
import weaver.hrm.User;

import java.util.Map;

public class ItxqlcServiceImpl extends Service implements ItxqlcService {

    @Override
    public Map<String, Object> getItxqXgxtList(Map<String, Object> params) {
        return commandExecutor.execute(new ItxqlcXgxtCmd(params));
    }

    @Override
    public Map<String, Object> getLsdpInfo(Map<String, Object> params,User user) {
        return commandExecutor.execute(new ItxqlcLdspCmd(params,user));
    }

    @Override
    public Map<String, Object> getXxjsbInfo(Map<String, Object> params) {
        return commandExecutor.execute(new ItxqlcXxjsbCmd(params));
    }

    @Override
    public Map<String, Object> createFreeNode(User user, Map<String, Object> params) {
        return commandExecutor.execute(new ItxqlcFreeNodeCmd(user,params));
    }


}
