package com.engine.htsc.lhcd.Web;

import com.alibaba.fastjson.JSON;
import com.engine.common.util.ServiceUtil;
import com.engine.htsc.lhcd.Service.LhcdWorkflowBaseService;
import com.engine.htsc.lhcd.Service.impl.LhcdWorkflowBaseServiceimpl;
import weaver.general.BaseBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

/**
 * @author xf
 * @version 1.0.0
 * @ClassName LhcdApi.java
 * @createTime 2021年12月27日 09:34:00
 */

public class LhcdApi {

    private LhcdWorkflowBaseService lhcdWorkflowBaseService()
    {
        return ServiceUtil.getService(LhcdWorkflowBaseServiceimpl.class);
    }

    @POST
    @Path("/checkCoDirectorNotice")
    @Produces({MediaType.TEXT_PLAIN})
    public String checkCoDirectorNotice(@Context HttpServletRequest request, @Context HttpServletResponse response){
        BaseBean bs = new BaseBean();
        Map<String, Object> apidatas = new HashMap<String, Object>();
        bs.writeLog("----UnionSealApplicationAction-----");
        try{
            String requestid = request.getParameter("requestid");
            String nodename = request.getParameter("nodename");
            apidatas = lhcdWorkflowBaseService().checkCoDirectorNotice(requestid,nodename);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }

        return JSON.toJSONString(apidatas);
    }


    @POST
    @Path("/noticeSignDeptCoDirector")
    @Produces({MediaType.TEXT_PLAIN})
    public String noticeSignDeptCoDirector(@Context HttpServletRequest request, @Context HttpServletResponse response){
        BaseBean bs = new BaseBean();
        Map<String, Object> apidatas = new HashMap<String, Object>();
        bs.writeLog("----UnionSealApplicationAction-----");
        try{
            String requestid = request.getParameter("requestid");
            String nodeid = request.getParameter("nodeid");
            String deptid = request.getParameter("deptid");
            apidatas = lhcdWorkflowBaseService().noticeSignDeptCoDirector(requestid,nodeid,deptid);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }

        return JSON.toJSONString(apidatas);
    }

}
