package com.engine.htsc.mhjc.service.impl;

import com.engine.core.impl.Service;
import com.engine.htsc.mhjc.cmd.*;
import com.engine.htsc.mhjc.service.HtscMhjcService;

import java.util.Map;

public class HtscMhjcServiceImpl  extends Service implements HtscMhjcService {

    /***
     *
     * @param params
     * @return
     */
    @Override
    public Map<String, Object> queryKanyueList(Map<String,Object> params) {
        return commandExecutor.execute(new HtscMhjcKanyueCmd(params));
    }

    /***
     *
     * @param params
     * @return
     */
    @Override
    public Map<String, Object> queryKanyueTotal(Map<String, Object> params) {
        return commandExecutor.execute(new HtscKanyueTotalCmd(params));
    }

    /**
     *
     * @param params
     * @return
     */
    @Override
    public Map<String, Object> getCoworkList(Map<String, Object> params) {
        return commandExecutor.execute(new HtscCoworkListCmd(params));
    }

    /***
     *
     * @param params
     * @return
     */
    @Override
    public Map<String, Object> getCoworTotal(Map<String, Object> params) {
        return commandExecutor.execute(new HtscCoworkTotleCmd(params));
    }

    /***
     *
     * @param params
     * @return
     */
    @Override
    public Map<String, Object> queryKanyueListForOld(Map<String, Object> params) {
        return commandExecutor.execute(new HtscKanyueForOldCmd(params));
    }

    @Override
    public Map<String, Object> getCoworkTaskList(Map<String, Object> params) {
        return commandExecutor.execute(new HtscCoworkTaskListCmd(params));
    }

    @Override
    public Map<String, Object> getGongGaoklist(Map<String, Object> params) {
        return commandExecutor.execute(new HtscGongGaoForOldCmd(params));
    }

    @Override
    public Map<String, Object> getTzydZylist(Map<String, Object> params) {
        return commandExecutor.execute(new HtscTzydZyCmd(params));
    }

    @Override
    public Map<String, Object> getkanyuelistforportal(Map<String, Object> params) {
        return commandExecutor.execute(new HtscKanyueForPortalCmd(params));
    }

    @Override
    public Map<String, Object> getgonggaolistforportal(Map<String, Object> params) {
        return commandExecutor.execute(new HtscGongGaoForPortalCmd(params));
    }

}
