package com.engine.htsc.payment.service;

import com.engine.htsc.payment.model.SendAppendicesTask;
import com.engine.htsc.payment.model.SendPDFTask;
import com.engine.htsc.payment.model.WfParams;

import java.util.List;
import java.util.concurrent.RecursiveAction;

public interface PaymentSyncService {

  void syncProcessPdfAndAllAppendix() throws Exception;

  List<SendPDFTask> syncProcessPdf(List<WfParams> branchWfParams) throws InterruptedException;

  List<SendAppendicesTask> syncAppendices(List<WfParams> branchWfParams);
}
