package com.engine.htsc.receipt.web;

import com.alibaba.fastjson.JSON;
import com.engine.common.util.ServiceUtil;
import com.engine.htsc.receipt.service.ReceiptAgentService;
import weaver.general.BaseBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

public class ReceiptAgentAction {

    ReceiptAgentService getService(){
        return ServiceUtil.getService(ReceiptAgentService.class);
    }

    @POST
    @Path("/getAgent")
    @Produces({MediaType.TEXT_PLAIN})
    public String getAgent(@Context HttpServletRequest request, @Context HttpServletResponse response){
        BaseBean bs = new BaseBean();
        Map<String, Object> apidatas = new HashMap<String, Object>();
        bs.writeLog("----receipt-----");
        try{
            String requestid = request.getParameter("requestid");
            String fieldvalue = request.getParameter("fieldvalue");

            ReceiptAgentService receiptAgentService = getService();
            apidatas = receiptAgentService.getAgent(requestid,fieldvalue);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }

        return JSON.toJSONString(apidatas);
    }
}
