package com.engine.htsc.seal.entity;


import java.io.Serializable;
import java.util.Map;


public class Signer implements Serializable {

    public String code;//证件编码
    public String codeType;//证件类型
    public String revokeFlag;//撤销状态
    public String sealId;//印章ID
    public String signNum;//签署顺序
    public String ownerType;//企业内部/外部标识
    public String signatoryType;//企业/个人标识
    public String keyWord;//关键字
    public String signMethod;//签署方的签署方式
    public String signedExamine;//签署后，下一签署方是否需要流程审批
    public String email;//邮箱
    public Map<String,String> seals;//印章集合

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getCodeType() {
        return codeType;
    }

    public void setCodeType(String codeType) {
        this.codeType = codeType;
    }

    public String getRevokeFlag() {
        return revokeFlag;
    }

    public void setRevokeFlag(String revokeFlag) {
        this.revokeFlag = revokeFlag;
    }

    public String getSealId() {
        return sealId;
    }

    public void setSealId(String sealId) {
        this.sealId = sealId;
    }

    public String getSignNum() {
        return signNum;
    }

    public void setSignNum(String signNum) {
        this.signNum = signNum;
    }

    public String getOwnerType() {
        return ownerType;
    }

    public void setOwnerType(String ownerType) {
        this.ownerType = ownerType;
    }

    public String getSignatoryType() {
        return signatoryType;
    }

    public void setSignatoryType(String signatoryType) {
        this.signatoryType = signatoryType;
    }

    public String getKeyWord() {
        return keyWord;
    }

    public void setKeyWord(String keyWord) {
        this.keyWord = keyWord;
    }

    public String getSignMethod() {
        return signMethod;
    }

    public void setSignMethod(String signMethod) {
        this.signMethod = signMethod;
    }

    public String getSignedExamine() {
        return signedExamine;
    }

    public void setSignedExamine(String signedExamine) {
        this.signedExamine = signedExamine;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public Map<String,String> getSeals() {
        return seals;
    }

    public void setSeals(Map<String,String> seals) {
        this.seals = seals;
    }
}
