package com.engine.htsc.trip.service.impl;

import com.engine.core.impl.Service;
import com.engine.htsc.trip.cmd.GetProjectByPageCmd;
import com.engine.htsc.trip.cmd.GetProjectCmd;
import com.engine.htsc.trip.service.GetProjectService;
import java.util.Map;

public class GetProjectServiceImpl extends Service implements GetProjectService {
  
  @Override
  public Map<String, Object> getProject(Map<String, Object> params) {
    return commandExecutor.execute(new GetProjectCmd(user, params));
  }
  
  @Override
  public Map<String, Object> getProjectByPage(Map<String, Object> params) {
    return commandExecutor.execute(new GetProjectByPageCmd(user, params));
  }
}
