package com.engine.htsc.cube.entity;

/**
 * {
 *   "sourceAuthor": "string",
 *   "sourceId": "string",
 *   "sourceMobileUrl": "string",
 *   "sourcePCUrl": "string",
 *   "sourceSystemCode": "string",
 *   "sourceTitle": "string",
 *   "sourceTypeCode": "string",
 *   "userId": "string"
 * }
 *
 * 收藏实体
 */
public class Favorite {
    /**
     * 来源系统租户id 指南针编码
     */
    private String sourceSystemCode;

    /**
     * 来源类型(业务系统提供)
     */
    private String sourceTypeCode;

    /**
     * 来源唯一编码（业务系统提供）
     */
    private String sourceId;

    /**
     * 来源标题
     */
    private String sourceTitle;

    /**
     * 来源作者
     */
    private String sourceAuthor ;

    /**
     * 来源PC端url
     */
    private String sourcePCUrl ;

    /**
     * 来源移动端端url
     */
    private String sourceMobileUrl ;

    /**
     * 处理人工号（调试使用）
     */
    private String userId;


    public String getSourceSystemCode() {
        return sourceSystemCode;
    }

    public void setSourceSystemCode(String sourceSystemCode) {
        this.sourceSystemCode = sourceSystemCode;
    }

    public String getSourceTypeCode() {
        return sourceTypeCode;
    }

    public void setSourceTypeCode(String sourceTypeCode) {
        this.sourceTypeCode = sourceTypeCode;
    }

    public String getSourceId() {
        return sourceId;
    }

    public void setSourceId(String sourceId) {
        this.sourceId = sourceId;
    }

    public String getSourceTitle() {
        return sourceTitle;
    }

    public void setSourceTitle(String sourceTitle) {
        this.sourceTitle = sourceTitle;
    }

    public String getSourceAuthor() {
        return sourceAuthor;
    }

    public void setSourceAuthor(String sourceAuthor) {
        this.sourceAuthor = sourceAuthor;
    }

    public String getSourcePCUrl() {
        return sourcePCUrl;
    }

    public void setSourcePCUrl(String sourcePCUrl) {
        this.sourcePCUrl = sourcePCUrl;
    }

    public String getSourceMobileUrl() {
        return sourceMobileUrl;
    }

    public void setSourceMobileUrl(String sourceMobileUrl) {
        this.sourceMobileUrl = sourceMobileUrl;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    @Override
    public String toString() {
        return "Favorite{" +
            "sourceSystemCode='" + sourceSystemCode + '\'' +
            ", sourceTypeCode='" + sourceTypeCode + '\'' +
            ", sourceId='" + sourceId + '\'' +
            ", sourceTitle='" + sourceTitle + '\'' +
            ", sourceAuthor='" + sourceAuthor + '\'' +
            ", sourcePCUrl='" + sourcePCUrl + '\'' +
            ", sourceMobileUrl='" + sourceMobileUrl + '\'' +
            ", userId='" + userId + '\'' +
            '}';
    }
}
