package com.engine.htsc.doc.cmd;

import weaver.general.BaseBean;

import java.util.Map;

public class LetterThread extends Thread  {

    private Map<String, Object> params;

    private String id;

    public LetterThread(Map<String, Object> params,String id) {
        this.params = params;
        this.id = id;
    }


    @Override
    public void run() {
        try {
            LetterReadCmd letterReadCmd = new LetterReadCmd();
            //送阅记录是否存在
            letterReadCmd.saveReaderByCode(params,id);
            super.run();
        }catch (Exception e){
            new BaseBean().writeLog("LetterThread执行异常:"+e.getMessage());
            e.printStackTrace();
        }
    }
}
