package com.engine.htsc.ityssq.service.impl;

import com.engine.core.impl.Service;
import com.engine.htsc.ityssq.cmd.ItyssqFreeNodeCmd;
import com.engine.htsc.ityssq.cmd.ItyssqNsryInfoCmd;
import com.engine.htsc.ityssq.service.ItyssqService;
import weaver.hrm.User;

import java.util.Map;

public class ItyssqServiceImpl extends Service implements ItyssqService {

    @Override
    public Map<String, Object> createFreeNode(User user, Map<String, Object> params) {
        return commandExecutor.execute(new ItyssqFreeNodeCmd(user,params));
    }

    @Override
    public Map<String, Object> getNsryInfo(Map<String, Object> params) {
        return commandExecutor.execute(new ItyssqNsryInfoCmd(params));
    }


}
