package com.engine.htsc.payment.pojo;

import java.io.Serializable;

public class BudgetData implements Serializable {

	private static final long serialVersionUID = -1673659956199314138L;
	private String relationCode;
	private String itemCode;
	private String itemName;

	public BudgetData() {
	}

	public BudgetData(String relationCode, String itemCode, String itemName) {
		this.relationCode = relationCode;
		this.itemCode = itemCode;
		this.itemName = itemName;
	}

	public String getRelationCode() {
		return relationCode;
	}

	public void setRelationCode(String relationCode) {
		this.relationCode = relationCode;
	}

	public String getItemCode() {
		return itemCode;
	}

	public void setItemCode(String itemCode) {
		this.itemCode = itemCode;
	}

	public String getItemName() {
		return itemName;
	}

	public void setItemName(String itemName) {
		this.itemName = itemName;
	}

	@Override
	public String toString() {
		return "BudgetData{" +
				"relationCode='" + relationCode + '\'' +
				", itemCode='" + itemCode + '\'' +
				", itemName='" + itemName + '\'' +
				'}';
	}
}
