package com.engine.htsc.payment.pojo;

import java.io.Serializable;

/**
 * 合同信息查询条件
 */
public class ContractRequestParam implements Serializable {

	private static final long serialVersionUID = 6178379156928967640L;

	/**
	 * 当前页码
	 */
	private Integer currentPage = 0;
	/**
	 * 分页数
	 */
	private Integer pageSize = 10;
	/**
	 * 工号
	 */
	private String userCode;
	/**
	 * 合同编号
	 */
	private String code;
	/**
	 * 合同名称
	 */
	private String name;

	public Integer getCurrentPage() {
		return currentPage;
	}

	public void setCurrentPage(Integer currentPage) {
		this.currentPage = currentPage;
	}

	public Integer getPageSize() {
		return pageSize;
	}

	public void setPageSize(Integer pageSize) {
		this.pageSize = pageSize;
	}

	public String getUserCode() {
		return userCode;
	}

	public void setUserCode(String userCode) {
		this.userCode = userCode;
	}

	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public ContractRequestParam() {
	}

	public ContractRequestParam(Integer currentPage, Integer pageSize, String userCode, String code, String name) {
		this.currentPage = currentPage;
		this.pageSize = pageSize;
		this.userCode = userCode;
		this.code = code;
		this.name = name;
	}

	@Override
	public String toString() {
		return "ContractRequestParam{" +
				"currentPage=" + currentPage +
				", pageSize=" + pageSize +
				", userCode='" + userCode + '\'' +
				", code='" + code + '\'' +
				", name='" + name + '\'' +
				'}';
	}
}
