package com.engine.htsc.payment.pojo;

import java.io.Serializable;

public class ItProjectQueryCondition implements Serializable {

	private static final long serialVersionUID = -5111040242910655952L;

	/**
	 * 分页
	 */
	private Integer pageNo = 1;

	private Integer pageSize = 10;

	private String code;

	private String name;

	private String key;

	public ItProjectQueryCondition() {
	}

	public ItProjectQueryCondition(Integer pageNo, Integer pageSize, String code, String name, String key) {
		this.pageNo = pageNo;
		this.pageSize = pageSize;
		this.code = code;
		this.name = name;
		this.key = key;
	}

	public Integer getPageNo() {
		return pageNo;
	}

	public void setPageNo(Integer pageNo) {
		this.pageNo = pageNo;
	}

	public Integer getPageSize() {
		return pageSize;
	}

	public void setPageSize(Integer pageSize) {
		this.pageSize = pageSize;
	}

	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getKey() {
		return key;
	}

	public void setKey(String key) {
		this.key = key;
	}

	@Override
	public String toString() {
		return "ItProjectQueryCondition{" +
				"pageNo=" + pageNo +
				", pageSize=" + pageSize +
				", code='" + code + '\'' +
				", name='" + name + '\'' +
				", key='" + key + '\'' +
				'}';
	}
}
