package com.engine.htsc.payment.pojo;

import com.alibaba.fastjson.annotation.JSONField;

import java.io.Serializable;

/**
 * 请求数据封装
 * 会计明细数据
 */
public class KjDetail implements Serializable {

	private static final long serialVersionUID = 7183358706483602009L;
	private String expenseDeptCode;
	private String expenseDept;
	private String expenseBadge;
	private String expensePerson;

	private SubjectData subjectData;
	@JSONField(name = "yssuanData")
	private BudgetData budgetData;
	private String priceRMB;
	private String money;
	private String projectCode;
	private String project;
	private String reason;

	public KjDetail() {
	}

	public KjDetail(String expenseDeptCode, String expenseDept, String expenseBadge, String expensePerson, SubjectData subjectData, BudgetData budgetData, String priceRMB, String money, String projectCode, String project, String reason) {
		this.expenseDeptCode = expenseDeptCode;
		this.expenseDept = expenseDept;
		this.expenseBadge = expenseBadge;
		this.expensePerson = expensePerson;
		this.subjectData = subjectData;
		this.budgetData = budgetData;
		this.priceRMB = priceRMB;
		this.money = money;
		this.projectCode = projectCode;
		this.project = project;
		this.reason = reason;
	}

	public String getExpenseDeptCode() {
		return expenseDeptCode;
	}

	public void setExpenseDeptCode(String expenseDeptCode) {
		this.expenseDeptCode = expenseDeptCode;
	}

	public String getExpenseDept() {
		return expenseDept;
	}

	public void setExpenseDept(String expenseDept) {
		this.expenseDept = expenseDept;
	}

	public String getExpenseBadge() {
		return expenseBadge;
	}

	public void setExpenseBadge(String expenseBadge) {
		this.expenseBadge = expenseBadge;
	}

	public String getExpensePerson() {
		return expensePerson;
	}

	public void setExpensePerson(String expensePerson) {
		this.expensePerson = expensePerson;
	}

	public SubjectData getSubjectData() {
		return subjectData;
	}

	public void setSubjectData(SubjectData subjectData) {
		this.subjectData = subjectData;
	}

	public BudgetData getBudgetData() {
		return budgetData;
	}

	public void setBudgetData(BudgetData budgetData) {
		this.budgetData = budgetData;
	}

	public String getPriceRMB() {
		return priceRMB;
	}

	public void setPriceRMB(String priceRMB) {
		this.priceRMB = priceRMB;
	}

	public String getMoney() {
		return money;
	}

	public void setMoney(String money) {
		this.money = money;
	}

	public String getProjectCode() {
		return projectCode;
	}

	public void setProjectCode(String projectCode) {
		this.projectCode = projectCode;
	}

	public String getProject() {
		return project;
	}

	public void setProject(String project) {
		this.project = project;
	}

	public String getReason() {
		return reason;
	}

	public void setReason(String reason) {
		this.reason = reason;
	}

	@Override
	public String toString() {
		return "KjDetail{" +
				"expenseDeptCode='" + expenseDeptCode + '\'' +
				", expenseDept='" + expenseDept + '\'' +
				", expenseBadge='" + expenseBadge + '\'' +
				", expensePerson='" + expensePerson + '\'' +
				", subjectData=" + subjectData +
				", budgetData=" + budgetData +
				", priceRMB='" + priceRMB + '\'' +
				", money='" + money + '\'' +
				", projectCode='" + projectCode + '\'' +
				", project='" + project + '\'' +
				", reason='" + reason + '\'' +
				'}';
	}
}
