package com.engine.htsc.payment.pojo;

/**
 * 请求数据封装
 * 支付明细数据
 */
public class PayDetail {

	private String payByBank;
	private String payByCash;
	private String bankName;
	private String bankAccount;
	private String employeeDept;
	private String employeeName;
	private String payee;
	private String employeeBadge;

	public PayDetail() {
	}

	public PayDetail(String payByBank, String payByCash, String bankName, String bankAccount, String employeeDept, String employeeName, String payee, String employeeBadge) {
		this.payByBank = payByBank;
		this.payByCash = payByCash;
		this.bankName = bankName;
		this.bankAccount = bankAccount;
		this.employeeDept = employeeDept;
		this.employeeName = employeeName;
		this.payee = payee;
		this.employeeBadge = employeeBadge;
	}

	public String getPayByBank() {
		return payByBank;
	}

	public void setPayByBank(String payByBank) {
		this.payByBank = payByBank;
	}

	public String getPayByCash() {
		return payByCash;
	}

	public void setPayByCash(String payByCash) {
		this.payByCash = payByCash;
	}

	public String getBankName() {
		return bankName;
	}

	public void setBankName(String bankName) {
		this.bankName = bankName;
	}

	public String getBankAccount() {
		return bankAccount;
	}

	public void setBankAccount(String bankAccount) {
		this.bankAccount = bankAccount;
	}

	public String getEmployeeDept() {
		return employeeDept;
	}

	public void setEmployeeDept(String employeeDept) {
		this.employeeDept = employeeDept;
	}

	public String getEmployeeName() {
		return employeeName;
	}

	public void setEmployeeName(String employeeName) {
		this.employeeName = employeeName;
	}

	public String getPayee() {
		return payee;
	}

	public void setPayee(String payee) {
		this.payee = payee;
	}

	public String getEmployeeBadge() {
		return employeeBadge;
	}

	public void setEmployeeBadge(String employeeBadge) {
		this.employeeBadge = employeeBadge;
	}

	@Override
	public String toString() {
		return "PayDetail{" +
				"payByBank='" + payByBank + '\'' +
				", payByCash='" + payByCash + '\'' +
				", bankName='" + bankName + '\'' +
				", bankAccount='" + bankAccount + '\'' +
				", employeeDept='" + employeeDept + '\'' +
				", employeeName='" + employeeName + '\'' +
				", payee='" + payee + '\'' +
				", employeeBadge='" + employeeBadge + '\'' +
				'}';
	}
}
