package com.engine.htsc.payment.pojo;

import java.util.ArrayList;
import java.util.List;

/**
 * 网报日志类
 */
public class WbLog {
	//流程编号
	private String requestNo;
	//调用人
	private String operator;
	//调用结果（泛微定义的成功标志）
	private String result;
	//	调用时间
	private String time;
	//第三方接口地址
	private String url;
	//第三方接口方法
	private String method;
	//调用原始参数或报文（clob字段）
	private String request;
	//调用结果（第三方接口原始返回结果）
	private String response;
	//	机器IP
	private String ip;

	public String getRequestNo() {
		return requestNo;
	}

	public void setRequestNo(String requestNo) {
		this.requestNo = requestNo;
	}

	public String getOperator() {
		return operator;
	}

	public void setOperator(String operator) {
		this.operator = operator;
	}

	public String getResult() {
		return result;
	}

	public void setResult(String result) {
		this.result = result;
	}

	public String getTime() {
		return time;
	}

	public void setTime(String time) {
		this.time = time;
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public String getMethod() {
		return method;
	}

	public void setMethod(String method) {
		this.method = method;
	}

	public String getRequest() {
		return request;
	}

	public void setRequest(String request) {
		this.request = request;
	}

	public String getResponse() {
		return response;
	}

	public void setResponse(String response) {
		this.response = response;
	}

	public String getIp() {
		return ip;
	}

	public void setIp(String ip) {
		this.ip = ip;
	}

	@Override
	public String toString() {
		return "WbLog{" +
				"requestNo='" + requestNo + '\'' +
				", operator='" + operator + '\'' +
				", result='" + result + '\'' +
				", time='" + time + '\'' +
				", url='" + url + '\'' +
				", method='" + method + '\'' +
				", request='" + request + '\'' +
				", response='" + response + '\'' +
				", ip='" + ip + '\'' +
				'}';
	}

	public List<Object> toList() {
		List<Object> objects = new ArrayList<>();
		objects.add(this.getRequestNo());
		objects.add(this.getOperator());
		objects.add(this.getResult());
		objects.add(this.getTime());
		objects.add(this.getUrl());
		objects.add(this.getMethod());
		objects.add(this.getRequest());
		objects.add(this.getResponse());
		objects.add(this.getIp());
		return objects;

	}

}
