package com.engine.htsc.payment.service;

import com.engine.htsc.payment.pojo.AutoRequestParam;

import java.util.Map;

/**
 * 员工慰问服务
 */
public interface StaffCodService {

  /**
   * 生成触发流程数据
   * @param rids 员工慰问流程ids
   * @return {@link AutoRequestParam} 多条流程数据归并
   */
  AutoRequestParam generateAutoRequestParamByStaffCodRid(String rids) throws Exception;

  /**
   * 自动触发工会流程
   * @param params 请求实体
   */
  Map<String, String> autoTriggerLaborUnionPayment(AutoRequestParam params) throws Exception;
}
