package com.engine.htsc.seal.entity;


import java.io.Serializable;
import java.util.List;

public class DocSign implements Serializable {

    public String docId;//文件编码
    public String docType;//文件类型
    public String fileAttachPatch;//文件路径
    public String fileNameDisplay;//文件名称
    public String signMethod;//签署类型
    public String acrossSealSkipPage;//骑缝章是否跳页加盖
    public String effectType;//交付类型
    public PrintSetting printSetting;//防伪打印信息
    public List<Signer> signers;//签署方信息
    public String validityStartDate;//签署开始时间
    public String validityEndDate;//签署结束时间
    public String uniqueKey;//存储网关的资源ID

    public String getDocId() {
        return docId;
    }

    public void setDocId(String docId) {
        this.docId = docId;
    }

    public String getDocType() {
        return docType;
    }

    public void setDocType(String docType) {
        this.docType = docType;
    }

    public String getFileAttachPatch() {
        return fileAttachPatch;
    }

    public void setFileAttachPatch(String fileAttachPatch) {
        this.fileAttachPatch = fileAttachPatch;
    }

    public String getFileNameDisplay() {
        return fileNameDisplay;
    }

    public void setFileNameDisplay(String fileNameDisplay) {
        this.fileNameDisplay = fileNameDisplay;
    }

    public String getSignMethod() {
        return signMethod;
    }

    public void setSignMethod(String signMethod) {
        this.signMethod = signMethod;
    }

    public String getAcrossSealSkipPage() {
        return acrossSealSkipPage;
    }

    public void setAcrossSealSkipPage(String acrossSealSkipPage) {
        this.acrossSealSkipPage = acrossSealSkipPage;
    }

    public String getEffectType() {
        return effectType;
    }

    public void setEffectType(String effectType) {
        this.effectType = effectType;
    }

    public PrintSetting getPrintSetting() {
        return printSetting;
    }

    public void setPrintSetting(PrintSetting printSetting) {
        this.printSetting = printSetting;
    }

    public List<Signer> getSigners() {
        return signers;
    }

    public void setSigners(List<Signer> signers) {
        this.signers = signers;
    }

    public String getValidityStartDate() {
        return validityStartDate;
    }

    public void setValidityStartDate(String validityStartDate) {
        this.validityStartDate = validityStartDate;
    }

    public String getValidityEndDate() {
        return validityEndDate;
    }

    public void setValidityEndDate(String validityEndDate) {
        this.validityEndDate = validityEndDate;
    }

    public String getUniqueKey() {
        return uniqueKey;
    }

    public void setUniqueKey(String uniqueKey) {
        this.uniqueKey = uniqueKey;
    }
}
