package com.engine.htsc.seal.jjhyy;

import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.htsc.seal.jjhyy.service.JjhyySealService;
import com.engine.htsc.seal.jjhyy.service.impl.JjhyySealServiceImpl;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;
import weaver.interfaces.htsc.GlobatTools.JAVATools;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

/**
 * @author K1810015
 * @version 1.0.0
 * @ClassName jjhyy.java
 * @createTime 2022年03月14日 15:37:00
 */
public class JjhyySealAction {


    private JjhyySealService jjhyySealService= ServiceUtil.getService(JjhyySealServiceImpl.class);

    @POST
    @Path("/sendjjhhtSeal")
    @Produces({MediaType.TEXT_PLAIN})
    public String sendjjhhtSeal(@Context HttpServletRequest request, @Context HttpServletResponse response){
        BaseBean bs = new BaseBean();
        bs.writeLog("-------------JjhyySealAction.sendjjhhtSeal-------------");
        String requestid = Util.null2String(request.getParameter("requestid"));
        String docids = Util.null2String(request.getParameter("docid"));
        String sealtype= Util.null2String(request.getParameter("sealtype"));
        User user = HrmUserVarify.getUser(request, response);
         Map<String,Object> map=new HashMap<>();
        map.put("requestid",requestid);
        map.put("docids",docids);
        map.put("sealtype",sealtype);
        return jjhyySealService.sendjjhyySeal(map,user);
    }




}
