package com.engine.htsc.seal.web;

import com.alibaba.fastjson.JSON;
import com.engine.common.util.ServiceUtil;
import com.engine.htsc.seal.service.LicenseService;
import weaver.general.BaseBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

public class LicenseAction {

    LicenseService getService(){
        return ServiceUtil.getService(LicenseService.class);
    }

    @POST
    @Path("/getLicenseListByDeptCode")
    @Produces({MediaType.TEXT_PLAIN})
    public String getLeader(@Context HttpServletRequest request, @Context HttpServletResponse response){
        BaseBean bs = new BaseBean();
        Map<String, Object> apidatas = new HashMap<String, Object>();
        bs.writeLog("----LicenseAction-----");
        try{
            String deptcode = request.getParameter("deptcode");
            String type = request.getParameter("type");

            LicenseService service = getService();
            apidatas = service.getLicenseListByDeptCode(deptcode,type);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }

        return JSON.toJSONString(apidatas);
    }
}
