package com.engine.htsc.subcompany.tools;

import com.engine.htsc.subcompany.model.ReportSequenceVO;
import com.engine.htsc.subcompany.model.UfZgsspl;
import com.engine.htsc.subcompany.model.ZgsUser;
import weaver.general.Util;
import weaver.interfaces.htsc.GlobatTools.JAVATools;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

public class ZgsclUfzgsServiceTools  extends UfzgsServiceTools {

    @Override
    public List<ReportSequenceVO> convertModelToVO(List<UfZgsspl> ufZgssplList, String userId, HashMap<String, String> map, String unumbercode) {
        List<ReportSequenceVO> resultList = new ArrayList<>();
        //获取人员及部门信息
        ZgsUser zgsUser = new ZgsUser(userId);
        //获取审批链List过滤条件
        List<UfZgsspl> ufFzjgsplRy = new ArrayList<>();
        List<UfZgsspl> ufFzjgsplBm = new ArrayList<>();
        List<UfZgsspl> ufFzjgsplJg = new ArrayList<>();
        //匹配条件的list
        List<UfZgsspl> ufFzjgsplR = new ArrayList<>();
        //过滤审批链
        for(UfZgsspl ufZgsspl:ufZgssplList){
            //判断条件
            if(null!=ufZgsspl.getTj()&&!"".equals(ufZgsspl.getTj())){
                if(!getConitionParams(ufZgsspl.getTj(),map)){
                    continue;
                }
            }
            List<String> list = Arrays.asList(Util.null2String(ufZgsspl.getBm()).split(","));
            if (ufZgsspl.getCxsprjs().equals("WK_"+zgsUser.getWorkCode())){
                ufFzjgsplRy.add(ufZgsspl);//单人，联合部分为董事会或执行委员会成员,且要是董事会或执行委员会的账号
            }else if (list.contains(zgsUser.getDepId())){
                ufFzjgsplBm.add(ufZgsspl);
            }else if (ufZgsspl.getJg().equals(zgsUser.getZgsDept().getDepTypeCode())&&"".equals(Util.null2String(ufZgsspl.getBm()))){
                ufFzjgsplJg.add(ufZgsspl);
            }
        }
        if (ufFzjgsplRy.size()>0){
            ufFzjgsplR.addAll(ufFzjgsplRy);
        }else if (ufFzjgsplBm.size()>0){
            ufFzjgsplR.addAll(ufFzjgsplBm);
        }else if (ufFzjgsplJg.size()>0){
            ufFzjgsplR.addAll(ufFzjgsplJg);
        }
        for(UfZgsspl ufZgsspl:ufFzjgsplR){
            JAVATools.writelog("筛选审批链id为："+ufZgsspl.getId());
            ReportSequenceVO reportSequenceVO = getVo(ufZgsspl,zgsUser,map,unumbercode);
            resultList.add(reportSequenceVO);
        }
        return resultList;
    }

}
