package com.engine.htsc.workflow.ld;

import weaver.conn.RecordSet;
import weaver.formmode.setup.ModeRightInfo;
import weaver.general.BaseBean;
import weaver.general.TimeUtil;
import weaver.general.Util;
import weaver.interfaces.htsc.GlobatTools.JAVATools;

import java.io.UnsupportedEncodingException;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: TODO()
 * <p>
 * Development(开发部门): OA项目组-泛微
 * <p>
 * Copyright(版权):
 * @date(创建时间): 2020/11/16 12:36
 * @author(作者): 李丹
 * <p>
 * Last modified(最后修改时间): 2020/11/16 12:36
 * <p>
 * Modified by(修改人): 李丹
 */
public class GovernmentWHUtil {

    public static synchronized String GovernmentWH(String wfid,String reqid,String zhtype,String uid){
        String wh = "";
        RecordSet rs = new RecordSet();
        BaseBean bb = new BaseBean();
        String year = TimeUtil.getCurrentDateString().substring(0,4);
        //---获取最大文号---
        String maxlsh = "";//最大流水号
        String zh = "";//字号
        int lsh = 1;//流水号
        String sql = "select max(wh) as maxwh from uf_dgtfwbh where nf='"+year+"' and zh='"+zhtype+"'";
        rs.executeQuery(sql);
        if(rs.next()){
            maxlsh = Util.null2String(rs.getString("maxwh"));
        }
        if(zhtype.equals("0")){
            zh = "华泰证党字";
        }else if(zhtype.equals("1")){
            zh = "华泰证工字";
        }else{
            zh = "华泰证团字";
        }
        String whid=whvf(reqid,zh,zhtype);
        if(!"".equals(whid)){
            return whid;
        }
        if(!maxlsh.equals("")){
            lsh = Integer.valueOf(maxlsh)+1;
        }
        wh = zh+"〔"+year+"〕"+lsh+"号";
        //---更新流程表---
        String tablename = "";
        sql = "select b.tablename from workflow_base a,workflow_bill b" +
                " where a.formid = b.id and a.id = "+wfid;
        rs.executeQuery(sql);
        if(rs.next()){
            tablename = Util.null2String(rs.getString("tablename"));
        }
        //new BaseBean().writeLog(tablename+"   "+sql+"  "+wfid);
        if(!tablename.equals("")){
            sql = "update "+tablename+" set wh='"+wh+"' where requestid='"+reqid+"'";
            rs.execute(sql);
            //---获取formmodeid---
            String dgtwbh_formmodeid = "";
            try {
                dgtwbh_formmodeid  = new String(Util.null2String(bb.getPropValue("JMdevelop", "dgtwbh_formmodeid")).getBytes("ISO-8859-1"),"UTF-8").trim();
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            }
            //---插入建模表---
            String currTime = TimeUtil.getCurrentTimeString();
            String time = currTime.substring(0,currTime.length()-3);
            sql = "insert into uf_dgtfwbh(zh,nf,wh,cjsj,lcid,formmodeid,modedatacreater,modedatacreatertype,modedatacreatedate,modedatacreatetime) "+
                    " values('" + zhtype + "','" + year + "','"+lsh+"','" + time + "','"+reqid+"',"+dgtwbh_formmodeid+","+uid+",0,'" + TimeUtil.getCurrentDateString() + "','" + TimeUtil.getOnlyCurrentTimeString() + "')";;
            boolean flag = rs.execute(sql);
            if (flag) {
                //---权限重构---
                String maxidsql = "select max(id) as id from uf_dgtfwbh";
                rs.execute(maxidsql);
                if (rs.next()) {
                    ModeRightInfo ModeRightInfo = new ModeRightInfo();
                    ModeRightInfo.setNewRight(true);
                    ModeRightInfo.editModeDataShare(Integer.valueOf(uid), Integer.valueOf(dgtwbh_formmodeid), rs.getInt("id"));
                }
            }
        }

        return wh;
    }

    public static String whvf(String lcid,String zh,String zhtype){
        String sql=" select wh,nf from uf_dgtfwbh where 1=1 ";
        Map<String,String> map=new HashMap<>();
        map.put("lcid",lcid);
        map.put("zh",zhtype);
        Map<String,Object> map2= JAVATools.GetTableToMap(sql,map);
        if(map2==null ||map2.size()<=0){
            return "";
        }
        String wh=Util.null2String(map2.get("wh"));
        String nf=Util.null2String(map2.get("nf"));
        if("".equals(wh) || "".equals(nf) ){
            return "";
        }else{
            return  zh+"〔"+nf+"〕"+wh+"号";
        }
    }
}
